Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.flagstone.transform
Class FSSolidLine

    java.lang.Object
      com.flagstone.transform.FSTransformObject
          com.flagstone.transform.FSLineStyle
              com.flagstone.transform.FSSolidLine

All Implemented Interfaces:
  java.lang.Cloneable

    public class FSSolidLine

extends FSLineStyle

FSSolidLine defines the width and colour of a line that is used when drawing the outline of a shape.

Attributes
width | The width of the line drawn in twips.
color | The colour used to draw the line.

All lines are drawn with rounded corners and end caps. Different join and line end styles can be created by drawing line segments as a sequence of filled shapes. With 1 twip equal to 1/20th of a pixel this technique can easily be used to draw the narrowest of visible lines.

Whether the alpha channel in the colour is used is determined by the class used to define the shape. Transparent colours are only supported from Flash 3 onwards. Simply specifying the level of transparency in the FSColor object is not sufficient.

# Examples

     FSSolidLine lineStyle = new FSSolidLine(20, new FSColor(0, 0, 0));

Draws a black line, 1 pixel wide.

     FSSolidLine lineStyle = new FSSolidLine(20, new FSColor(255, 0, 0, 128));

Draws a transparent red line, 1 pixel wide. If the alpha channel is not specified then the value defaults to 255 generating a completely opaque colour.

Flash only supports contiguous lines. Dashed line styles can be created by drawing the line as a series of short line segments by interspersing FSShapeStyle objects to move the current point in between the FSLine objects that draw the line segments.

     // define the line style
     lineStyles.add(new FSSolidLine(20, new FSColor(0, 0, 0)));

     // Select the line style
     shape.add(new FSShapeStyle(1, 0, 0));

     // Draw the dashed line with lines and gaps each 5 pixels long
     shape.add(new FSShapeStyle(1, 0, 0));

     for (int i = 0; i < 10; i++)
     {
            shape.add(new FSLine(100, 0));
            shape.add(new FSShapeStyle(0, 0, 0));
            shape.add(new FSLine(100, 0));
     }

# History

The FSSolidLine class represents the LineStyle structure from the Macromedia Flash (SWF) File Format Specification. It was introduced in Flash 1. Support for transparent colours was added in Flash 3.

Constructor Summary
`FSSolidLine(FSCoder coder)` Construct an FSSolidLine object, initalizing it with values decoded from an encoded object.
`FSSolidLine(FSSolidLine obj)` Constructs an FSSolidLine object by copying values from an existing object.
`FSSolidLine(int aWidth, FSColor aColor)` Constructs an FSSolidLine, specifying the width and colour of the line.

Method Summary
`void` | `appendDescription(java.lang.StringBuffer buffer, int depth)` AppendDescription is used to present a string description of the object including all nested objects up to a specified depth.
`java.lang.Object` | `clone()` Creates a deep copy of the entire object.
`void` | `decode(FSCoder coder)`
`void` | `encode(FSCoder coder)`
`boolean` | `equals(java.lang.Object anObject)` Returns true if anObject is equal to this one.
`FSColor` | `getColor()` Gets the colour of the line.
`int` | `getWidth()` Gets the width of the line.
`int` | `length(FSCoder coder)`
`void` | `setColor(FSColor aColor)` Sets the colour of the line.
`void` | `setWidth(int aNumber)` Sets the width of the line.

Methods inherited from class com.flagstone.transform.FSTransformObject
`name, toString`

Methods inherited from class java.lang.Object
`finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### FSSolidLine

    public FSSolidLine(FSCoder coder)

  Construct an FSSolidLine object, initalizing it with values decoded from an encoded object.

  Parameters:
    `coder` - an FSCoder containing the binary data.

### FSSolidLine

    public FSSolidLine(int aWidth,
                       FSColor aColor)

  Constructs an FSSolidLine, specifying the width and colour of the line.

  Parameters:
    `aWidth` - the width of the line.
    `aColor` - the colour of the line.

### FSSolidLine

    public FSSolidLine(FSSolidLine obj)

  Constructs an FSSolidLine object by copying values from an existing object.

  Parameters:
    `obj` - an FSSolidLine object.

Method Detail

### getWidth

    public int getWidth()

  Gets the width of the line.

  Returns:
    the width of the line.

### getColor

    public FSColor getColor()

  Gets the colour of the line.

  Returns:
    the colour for the line.

### setWidth

    public void setWidth(int aNumber)

  Sets the width of the line.

  Parameters:
    `aNumber` - the width of the line.

### setColor

    public void setColor(FSColor aColor)

  Sets the colour of the line.

  Parameters:
    `aColor` - the colour of the line.

### clone

    public java.lang.Object clone()

  Description copied from class: `FSTransformObject`
  Creates a deep copy of the entire object.

  Overrides:
    `clone` in class `FSTransformObject`
  Returns:
    a copy of the object.

### equals

    public boolean equals(java.lang.Object anObject)

  Description copied from class: `FSTransformObject`
  Returns true if anObject is equal to this one. Objects are considered equal if they would generate identical binary data when they are encoded to a Flash file.

  Overrides:
    `equals` in class `FSTransformObject`
  Returns:
    true if this object would be identical to anObject when encoded.

### appendDescription

    public void appendDescription(java.lang.StringBuffer buffer,
                                  int depth)

  Description copied from class: `FSTransformObject`
  AppendDescription is used to present a string description of the object including all nested objects up to a specified depth. This method provide a more controlled way of creating a string representation of an object since large objects such as font or shape definitions can contain dozens of nested objects. The representation of the object is appended to the StringBuffer, showing the name of the class and values of the attributes it contains. If the object contains any attributes that are objects then the object graph will be traversed up to the specified depth. If objects are nested at a level less than specified depth then the full string representation of the object is displayed. For objects at the specified depth only the name of the class is displayed. Any objects below this depth are not displayed.

  Specified by:
    `appendDescription` in class `FSTransformObject`
  Parameters:
    `buffer` - a StringBuffer to which the description of each object is appended.
    `depth` - the maximum level of nesting up to which objects will be displayed.

### length

    public int length(FSCoder coder)

  Specified by:
    `length` in class `FSTransformObject`

### encode

    public void encode(FSCoder coder)

  Specified by:
    `encode` in class `FSTransformObject`

### decode

    public void decode(FSCoder coder)

  Specified by:
    `decode` in class `FSTransformObject`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD